/***************************************************************************
                          cdownloadobjects.cpp  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdownloadobjects.h"

/** */
DCTransferFileItem::DCTransferFileItem()
{
	eMedium        = eltNONE;
	sRemoteName    = "";
	sLocalRootPath = "";
	sLocalPath     = "";
	sLocalName     = "";
	eState         = etfsNONE;
	lSize          = 0;
	lStartPosition = 0;
	lCurrentPosition = 0;
	lEndPosition   = 0;
	bMultiDownload = FALSE;
	ID             = 0;
}

/** */
DCTransferFileItem::~DCTransferFileItem()
{
}


/** */
void DCTransferFileItem::copy( DCTransferFileItem * p )
{
	if(!p)
		return;

	eMedium        = p->eMedium;
	sRemoteName    = p->sRemoteName;
	sLocalRootPath = p->sLocalRootPath;
	sLocalPath     = p->sLocalPath;
	sLocalName     = p->sLocalName;
	eState         = p->eState;
	lSize          = p->lSize;
	lStartPosition = p->lStartPosition;
	lEndPosition   = p->lEndPosition;
	bMultiDownload = p->bMultiDownload;
	ID             = p->ID;
}

/** */
DCTransferItem::DCTransferItem()
{
	eState      = etwsWAIT;
	sNick       = "";
	sHubName    = "";
	sHubHost    = "";
	timeTimeout = 0;
	ID          = 0;

	pFileList     = new CList<DCTransferFileItem>;
	pTransferList = new CList<CTransfer>;
}

/** */
DCTransferItem::~DCTransferItem()
{
	if (pFileList)
	{
		pFileList->Clear();
		delete pFileList;
		pFileList = 0;
	}

	if(pTransferList)
	{
		pTransferList->Clear();
		delete pTransferList;
		pTransferList = 0;
	}
}

/** */
void DCTransferItem::copy( DCTransferItem * p )
{
	if(!p)
		return;

	eState      = p->eState;
	sNick       = p->sNick;
	sHubName    = p->sHubName;
	sHubHost    = p->sHubHost;
	timeTimeout = p->timeTimeout;
	ID          = p->ID;

	pTransferList->Clear();

	DCTransferFileItem * TransferFileItem = 0;

	while( (TransferFileItem=p->pFileList->Next(TransferFileItem)) != 0 )
	{
		DCTransferFileItem * tfi = new DCTransferFileItem();

		*tfi = TransferFileItem;
		pFileList->Add(tfi);
	}
}
