/***************************************************************************
                          cdownloadobjects.h  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDOWNLOADOBJECTS_H
#define CDOWNLOADOBJECTS_H

#include <time.h>

#include <dclib/dcos.h>
#include <dclib/dcobject.h>
#include <dclib/cobject.h>
#include <dclib/clist.h>
#include <dclib/cstring.h>
#include <dclib/ctransfer.h>
#include <dclib/cbytearray.h>

/**
  *@author Mathias Kster
  */

class DLL_EXPORT DCTransferFileItem : public CObject {
public:
	/** */
	DCTransferFileItem();
	/** */
	virtual ~DCTransferFileItem();

	/** */
	DCTransferFileItem & operator = ( DCTransferFileItem * p ) { copy(p); return *this; };

	/** file or buffer */
	eltMedium eMedium;
	/** full remote filename */
	CString sRemoteName;
	/** the download root path or user specific root path */
	CString sLocalRootPath;
	/** the local path for download dir */
	CString sLocalPath;
	/** the local filename */
	CString sLocalName;
	/** */
	eTransferFileState eState;
	/** file size */
	ulonglong lSize;
	/** current file position */
	ulonglong lStartPosition;
	/** current file position */
	ulonglong lCurrentPosition;
	/** file end position */
	ulonglong lEndPosition;
	/** multi download */
	bool bMultiDownload;
	/** */
	ulonglong ID;

private:
	/** */
	void copy( DCTransferFileItem * p );
};

class DLL_EXPORT DCTransferItem : public CObject {
public:
	/** */
	DCTransferItem();
	/** */
	virtual ~DCTransferItem();

	/** */
	DCTransferItem & operator = ( DCTransferItem * p ) { copy(p); return *this; };

	/** */
	CString sNick;
	/** */
	CString sHubName;
	/** */
	CString sHubHost;
	/** */
	time_t timeTimeout;
	/** */
	eTransferWaitState eState;
	/** */
	CList<DCTransferFileItem> * pFileList;
	/** */
	CList<CTransfer> * pTransferList;
	/** */
	ulonglong ID;
	/** */
	CString sUserFileList;

private:
	/** */
	void copy( DCTransferItem * p );
};

#endif
